/*
 * Docs Dispatcher API - API document(s) generation
 * Docs.io API enables you to generate files (currently DOCx, XLSx, PPTx, PDF, HTML, JPG/PNG/SVG) from a template and JSON data. You can just download resulting file, send email with generated attachments or compose services.
 *
 * The version of the OpenAPI document: 3.1.1
 * Contact: tech@docs-dispatcher.io
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package io.docs_dispatcher.client.model;

import java.util.Objects;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.docs_dispatcher.client.model.Address;
import io.docs_dispatcher.client.model.DeferredTargetRequest;
import io.docs_dispatcher.client.model.FileContentRequest;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import org.openapitools.jackson.nullable.JsonNullable;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;
import com.google.gson.TypeAdapter;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;

import io.docs_dispatcher.client.JSON;

/**
 * PostalRequest
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2024-03-23T16:40:16.535479755Z[Etc/UTC]", comments = "Generator version: 7.5.0-SNAPSHOT")
public class PostalRequest {
  public static final String SERIALIZED_NAME_PROVIDER = "provider";
  @SerializedName(SERIALIZED_NAME_PROVIDER)
  private String provider;

  public static final String SERIALIZED_NAME_SUBJECT = "subject";
  @SerializedName(SERIALIZED_NAME_SUBJECT)
  private String subject;

  public static final String SERIALIZED_NAME_SENDER = "sender";
  @SerializedName(SERIALIZED_NAME_SENDER)
  private Address sender;

  public static final String SERIALIZED_NAME_RECEIVERS = "receivers";
  @SerializedName(SERIALIZED_NAME_RECEIVERS)
  private List<Address> receivers = new ArrayList<>();

  public static final String SERIALIZED_NAME_DOCUMENTS = "documents";
  @SerializedName(SERIALIZED_NAME_DOCUMENTS)
  private List<FileContentRequest> documents = new ArrayList<>();

  public static final String SERIALIZED_NAME_DATA = "data";
  @SerializedName(SERIALIZED_NAME_DATA)
  private Object data = null;

  /**
   * Gets or Sets envelopeFormat
   */
  @JsonAdapter(EnvelopeFormatEnum.Adapter.class)
  public enum EnvelopeFormatEnum {
    C4("C4"),
    
    C5("C5"),
    
    C6("C6"),
    
    AUTO("AUTO");

    private String value;

    EnvelopeFormatEnum(String value) {
      this.value = value;
    }

    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    public static EnvelopeFormatEnum fromValue(String value) {
      for (EnvelopeFormatEnum b : EnvelopeFormatEnum.values()) {
        if (b.value.equals(value)) {
          return b;
        }
      }
      throw new IllegalArgumentException("Unexpected value '" + value + "'");
    }

    public static class Adapter extends TypeAdapter<EnvelopeFormatEnum> {
      @Override
      public void write(final JsonWriter jsonWriter, final EnvelopeFormatEnum enumeration) throws IOException {
        jsonWriter.value(enumeration.getValue());
      }

      @Override
      public EnvelopeFormatEnum read(final JsonReader jsonReader) throws IOException {
        String value =  jsonReader.nextString();
        return EnvelopeFormatEnum.fromValue(value);
      }
    }

    public static void validateJsonElement(JsonElement jsonElement) throws IOException {
      String value = jsonElement.getAsString();
      EnvelopeFormatEnum.fromValue(value);
    }
  }

  public static final String SERIALIZED_NAME_ENVELOPE_FORMAT = "envelopeFormat";
  @SerializedName(SERIALIZED_NAME_ENVELOPE_FORMAT)
  private EnvelopeFormatEnum envelopeFormat;

  /**
   * Gets or Sets colorMode
   */
  @JsonAdapter(ColorModeEnum.Adapter.class)
  public enum ColorModeEnum {
    COLOR("COLOR"),
    
    BW("BW");

    private String value;

    ColorModeEnum(String value) {
      this.value = value;
    }

    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    public static ColorModeEnum fromValue(String value) {
      for (ColorModeEnum b : ColorModeEnum.values()) {
        if (b.value.equals(value)) {
          return b;
        }
      }
      throw new IllegalArgumentException("Unexpected value '" + value + "'");
    }

    public static class Adapter extends TypeAdapter<ColorModeEnum> {
      @Override
      public void write(final JsonWriter jsonWriter, final ColorModeEnum enumeration) throws IOException {
        jsonWriter.value(enumeration.getValue());
      }

      @Override
      public ColorModeEnum read(final JsonReader jsonReader) throws IOException {
        String value =  jsonReader.nextString();
        return ColorModeEnum.fromValue(value);
      }
    }

    public static void validateJsonElement(JsonElement jsonElement) throws IOException {
      String value = jsonElement.getAsString();
      ColorModeEnum.fromValue(value);
    }
  }

  public static final String SERIALIZED_NAME_COLOR_MODE = "colorMode";
  @SerializedName(SERIALIZED_NAME_COLOR_MODE)
  private ColorModeEnum colorMode;

  /**
   * Gets or Sets postage
   */
  @JsonAdapter(PostageEnum.Adapter.class)
  public enum PostageEnum {
    ECO("ECO"),
    
    REGISTERED_LETTER("REGISTERED_LETTER"),
    
    REGISTERED_LETTER_WITH_ACK("REGISTERED_LETTER_WITH_ACK"),
    
    FAST("FAST"),
    
    FAST_TRACKED("FAST_TRACKED"),
    
    SLOW("SLOW"),
    
    SLOW_TRACKED("SLOW_TRACKED");

    private String value;

    PostageEnum(String value) {
      this.value = value;
    }

    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    public static PostageEnum fromValue(String value) {
      for (PostageEnum b : PostageEnum.values()) {
        if (b.value.equals(value)) {
          return b;
        }
      }
      throw new IllegalArgumentException("Unexpected value '" + value + "'");
    }

    public static class Adapter extends TypeAdapter<PostageEnum> {
      @Override
      public void write(final JsonWriter jsonWriter, final PostageEnum enumeration) throws IOException {
        jsonWriter.value(enumeration.getValue());
      }

      @Override
      public PostageEnum read(final JsonReader jsonReader) throws IOException {
        String value =  jsonReader.nextString();
        return PostageEnum.fromValue(value);
      }
    }

    public static void validateJsonElement(JsonElement jsonElement) throws IOException {
      String value = jsonElement.getAsString();
      PostageEnum.fromValue(value);
    }
  }

  public static final String SERIALIZED_NAME_POSTAGE = "postage";
  @SerializedName(SERIALIZED_NAME_POSTAGE)
  private PostageEnum postage;

  public static final String SERIALIZED_NAME_BOTH_SIDES = "bothSides";
  @SerializedName(SERIALIZED_NAME_BOTH_SIDES)
  private Boolean bothSides;

  public static final String SERIALIZED_NAME_TARGET_FILENAME = "targetFilename";
  @SerializedName(SERIALIZED_NAME_TARGET_FILENAME)
  private String targetFilename;

  public static final String SERIALIZED_NAME_SETTINGS = "settings";
  @SerializedName(SERIALIZED_NAME_SETTINGS)
  private Object settings;

  public static final String SERIALIZED_NAME_TARGETS = "targets";
  @SerializedName(SERIALIZED_NAME_TARGETS)
  private List<DeferredTargetRequest> targets = new ArrayList<>();

  public PostalRequest() {
  }

  public PostalRequest provider(String provider) {
    this.provider = provider;
    return this;
  }

   /**
   * Get provider
   * @return provider
  **/
  @javax.annotation.Nullable
  public String getProvider() {
    return provider;
  }

  public void setProvider(String provider) {
    this.provider = provider;
  }


  public PostalRequest subject(String subject) {
    this.subject = subject;
    return this;
  }

   /**
   * Get subject
   * @return subject
  **/
  @javax.annotation.Nullable
  public String getSubject() {
    return subject;
  }

  public void setSubject(String subject) {
    this.subject = subject;
  }


  public PostalRequest sender(Address sender) {
    this.sender = sender;
    return this;
  }

   /**
   * Get sender
   * @return sender
  **/
  @javax.annotation.Nullable
  public Address getSender() {
    return sender;
  }

  public void setSender(Address sender) {
    this.sender = sender;
  }


  public PostalRequest receivers(List<Address> receivers) {
    this.receivers = receivers;
    return this;
  }

  public PostalRequest addReceiversItem(Address receiversItem) {
    if (this.receivers == null) {
      this.receivers = new ArrayList<>();
    }
    this.receivers.add(receiversItem);
    return this;
  }

   /**
   * Get receivers
   * @return receivers
  **/
  @javax.annotation.Nullable
  public List<Address> getReceivers() {
    return receivers;
  }

  public void setReceivers(List<Address> receivers) {
    this.receivers = receivers;
  }


  public PostalRequest documents(List<FileContentRequest> documents) {
    this.documents = documents;
    return this;
  }

  public PostalRequest addDocumentsItem(FileContentRequest documentsItem) {
    if (this.documents == null) {
      this.documents = new ArrayList<>();
    }
    this.documents.add(documentsItem);
    return this;
  }

   /**
   * Get documents
   * @return documents
  **/
  @javax.annotation.Nullable
  public List<FileContentRequest> getDocuments() {
    return documents;
  }

  public void setDocuments(List<FileContentRequest> documents) {
    this.documents = documents;
  }


  public PostalRequest data(Object data) {
    this.data = data;
    return this;
  }

   /**
   * Get data
   * @return data
  **/
  @javax.annotation.Nullable
  public Object getData() {
    return data;
  }

  public void setData(Object data) {
    this.data = data;
  }


  public PostalRequest envelopeFormat(EnvelopeFormatEnum envelopeFormat) {
    this.envelopeFormat = envelopeFormat;
    return this;
  }

   /**
   * Get envelopeFormat
   * @return envelopeFormat
  **/
  @javax.annotation.Nullable
  public EnvelopeFormatEnum getEnvelopeFormat() {
    return envelopeFormat;
  }

  public void setEnvelopeFormat(EnvelopeFormatEnum envelopeFormat) {
    this.envelopeFormat = envelopeFormat;
  }


  public PostalRequest colorMode(ColorModeEnum colorMode) {
    this.colorMode = colorMode;
    return this;
  }

   /**
   * Get colorMode
   * @return colorMode
  **/
  @javax.annotation.Nullable
  public ColorModeEnum getColorMode() {
    return colorMode;
  }

  public void setColorMode(ColorModeEnum colorMode) {
    this.colorMode = colorMode;
  }


  public PostalRequest postage(PostageEnum postage) {
    this.postage = postage;
    return this;
  }

   /**
   * Get postage
   * @return postage
  **/
  @javax.annotation.Nullable
  public PostageEnum getPostage() {
    return postage;
  }

  public void setPostage(PostageEnum postage) {
    this.postage = postage;
  }


  public PostalRequest bothSides(Boolean bothSides) {
    this.bothSides = bothSides;
    return this;
  }

   /**
   * Get bothSides
   * @return bothSides
  **/
  @javax.annotation.Nullable
  public Boolean getBothSides() {
    return bothSides;
  }

  public void setBothSides(Boolean bothSides) {
    this.bothSides = bothSides;
  }


  public PostalRequest targetFilename(String targetFilename) {
    this.targetFilename = targetFilename;
    return this;
  }

   /**
   * Get targetFilename
   * @return targetFilename
  **/
  @javax.annotation.Nullable
  public String getTargetFilename() {
    return targetFilename;
  }

  public void setTargetFilename(String targetFilename) {
    this.targetFilename = targetFilename;
  }


  public PostalRequest settings(Object settings) {
    this.settings = settings;
    return this;
  }

   /**
   * Get settings
   * @return settings
  **/
  @javax.annotation.Nullable
  public Object getSettings() {
    return settings;
  }

  public void setSettings(Object settings) {
    this.settings = settings;
  }


  public PostalRequest targets(List<DeferredTargetRequest> targets) {
    this.targets = targets;
    return this;
  }

  public PostalRequest addTargetsItem(DeferredTargetRequest targetsItem) {
    if (this.targets == null) {
      this.targets = new ArrayList<>();
    }
    this.targets.add(targetsItem);
    return this;
  }

   /**
   * Get targets
   * @return targets
  **/
  @javax.annotation.Nullable
  public List<DeferredTargetRequest> getTargets() {
    return targets;
  }

  public void setTargets(List<DeferredTargetRequest> targets) {
    this.targets = targets;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    PostalRequest postalRequest = (PostalRequest) o;
    return Objects.equals(this.provider, postalRequest.provider) &&
        Objects.equals(this.subject, postalRequest.subject) &&
        Objects.equals(this.sender, postalRequest.sender) &&
        Objects.equals(this.receivers, postalRequest.receivers) &&
        Objects.equals(this.documents, postalRequest.documents) &&
        Objects.equals(this.data, postalRequest.data) &&
        Objects.equals(this.envelopeFormat, postalRequest.envelopeFormat) &&
        Objects.equals(this.colorMode, postalRequest.colorMode) &&
        Objects.equals(this.postage, postalRequest.postage) &&
        Objects.equals(this.bothSides, postalRequest.bothSides) &&
        Objects.equals(this.targetFilename, postalRequest.targetFilename) &&
        Objects.equals(this.settings, postalRequest.settings) &&
        Objects.equals(this.targets, postalRequest.targets);
  }

  private static <T> boolean equalsNullable(JsonNullable<T> a, JsonNullable<T> b) {
    return a == b || (a != null && b != null && a.isPresent() && b.isPresent() && Objects.deepEquals(a.get(), b.get()));
  }

  @Override
  public int hashCode() {
    return Objects.hash(provider, subject, sender, receivers, documents, data, envelopeFormat, colorMode, postage, bothSides, targetFilename, settings, targets);
  }

  private static <T> int hashCodeNullable(JsonNullable<T> a) {
    if (a == null) {
      return 1;
    }
    return a.isPresent() ? Arrays.deepHashCode(new Object[]{a.get()}) : 31;
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class PostalRequest {\n");
    sb.append("    provider: ").append(toIndentedString(provider)).append("\n");
    sb.append("    subject: ").append(toIndentedString(subject)).append("\n");
    sb.append("    sender: ").append(toIndentedString(sender)).append("\n");
    sb.append("    receivers: ").append(toIndentedString(receivers)).append("\n");
    sb.append("    documents: ").append(toIndentedString(documents)).append("\n");
    sb.append("    data: ").append(toIndentedString(data)).append("\n");
    sb.append("    envelopeFormat: ").append(toIndentedString(envelopeFormat)).append("\n");
    sb.append("    colorMode: ").append(toIndentedString(colorMode)).append("\n");
    sb.append("    postage: ").append(toIndentedString(postage)).append("\n");
    sb.append("    bothSides: ").append(toIndentedString(bothSides)).append("\n");
    sb.append("    targetFilename: ").append(toIndentedString(targetFilename)).append("\n");
    sb.append("    settings: ").append(toIndentedString(settings)).append("\n");
    sb.append("    targets: ").append(toIndentedString(targets)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("provider");
    openapiFields.add("subject");
    openapiFields.add("sender");
    openapiFields.add("receivers");
    openapiFields.add("documents");
    openapiFields.add("data");
    openapiFields.add("envelopeFormat");
    openapiFields.add("colorMode");
    openapiFields.add("postage");
    openapiFields.add("bothSides");
    openapiFields.add("targetFilename");
    openapiFields.add("settings");
    openapiFields.add("targets");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
  }

 /**
  * Validates the JSON Element and throws an exception if issues found
  *
  * @param jsonElement JSON Element
  * @throws IOException if the JSON Element is invalid with respect to PostalRequest
  */
  public static void validateJsonElement(JsonElement jsonElement) throws IOException {
      if (jsonElement == null) {
        if (!PostalRequest.openapiRequiredFields.isEmpty()) { // has required fields but JSON element is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in PostalRequest is not found in the empty JSON string", PostalRequest.openapiRequiredFields.toString()));
        }
      }

      Set<Map.Entry<String, JsonElement>> entries = jsonElement.getAsJsonObject().entrySet();
      // check to see if the JSON string contains additional fields
      for (Map.Entry<String, JsonElement> entry : entries) {
        if (!PostalRequest.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `PostalRequest` properties. JSON: %s", entry.getKey(), jsonElement.toString()));
        }
      }
        JsonObject jsonObj = jsonElement.getAsJsonObject();
      if ((jsonObj.get("provider") != null && !jsonObj.get("provider").isJsonNull()) && !jsonObj.get("provider").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `provider` to be a primitive type in the JSON string but got `%s`", jsonObj.get("provider").toString()));
      }
      if ((jsonObj.get("subject") != null && !jsonObj.get("subject").isJsonNull()) && !jsonObj.get("subject").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `subject` to be a primitive type in the JSON string but got `%s`", jsonObj.get("subject").toString()));
      }
      // validate the optional field `sender`
      if (jsonObj.get("sender") != null && !jsonObj.get("sender").isJsonNull()) {
        Address.validateJsonElement(jsonObj.get("sender"));
      }
      if (jsonObj.get("receivers") != null && !jsonObj.get("receivers").isJsonNull()) {
        JsonArray jsonArrayreceivers = jsonObj.getAsJsonArray("receivers");
        if (jsonArrayreceivers != null) {
          // ensure the json data is an array
          if (!jsonObj.get("receivers").isJsonArray()) {
            throw new IllegalArgumentException(String.format("Expected the field `receivers` to be an array in the JSON string but got `%s`", jsonObj.get("receivers").toString()));
          }

          // validate the optional field `receivers` (array)
          for (int i = 0; i < jsonArrayreceivers.size(); i++) {
            Address.validateJsonElement(jsonArrayreceivers.get(i));
          };
        }
      }
      if (jsonObj.get("documents") != null && !jsonObj.get("documents").isJsonNull()) {
        JsonArray jsonArraydocuments = jsonObj.getAsJsonArray("documents");
        if (jsonArraydocuments != null) {
          // ensure the json data is an array
          if (!jsonObj.get("documents").isJsonArray()) {
            throw new IllegalArgumentException(String.format("Expected the field `documents` to be an array in the JSON string but got `%s`", jsonObj.get("documents").toString()));
          }

          // validate the optional field `documents` (array)
          for (int i = 0; i < jsonArraydocuments.size(); i++) {
            FileContentRequest.validateJsonElement(jsonArraydocuments.get(i));
          };
        }
      }
      if ((jsonObj.get("envelopeFormat") != null && !jsonObj.get("envelopeFormat").isJsonNull()) && !jsonObj.get("envelopeFormat").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `envelopeFormat` to be a primitive type in the JSON string but got `%s`", jsonObj.get("envelopeFormat").toString()));
      }
      // validate the optional field `envelopeFormat`
      if (jsonObj.get("envelopeFormat") != null && !jsonObj.get("envelopeFormat").isJsonNull()) {
        EnvelopeFormatEnum.validateJsonElement(jsonObj.get("envelopeFormat"));
      }
      if ((jsonObj.get("colorMode") != null && !jsonObj.get("colorMode").isJsonNull()) && !jsonObj.get("colorMode").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `colorMode` to be a primitive type in the JSON string but got `%s`", jsonObj.get("colorMode").toString()));
      }
      // validate the optional field `colorMode`
      if (jsonObj.get("colorMode") != null && !jsonObj.get("colorMode").isJsonNull()) {
        ColorModeEnum.validateJsonElement(jsonObj.get("colorMode"));
      }
      if ((jsonObj.get("postage") != null && !jsonObj.get("postage").isJsonNull()) && !jsonObj.get("postage").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `postage` to be a primitive type in the JSON string but got `%s`", jsonObj.get("postage").toString()));
      }
      // validate the optional field `postage`
      if (jsonObj.get("postage") != null && !jsonObj.get("postage").isJsonNull()) {
        PostageEnum.validateJsonElement(jsonObj.get("postage"));
      }
      if ((jsonObj.get("targetFilename") != null && !jsonObj.get("targetFilename").isJsonNull()) && !jsonObj.get("targetFilename").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `targetFilename` to be a primitive type in the JSON string but got `%s`", jsonObj.get("targetFilename").toString()));
      }
      if (jsonObj.get("targets") != null && !jsonObj.get("targets").isJsonNull()) {
        JsonArray jsonArraytargets = jsonObj.getAsJsonArray("targets");
        if (jsonArraytargets != null) {
          // ensure the json data is an array
          if (!jsonObj.get("targets").isJsonArray()) {
            throw new IllegalArgumentException(String.format("Expected the field `targets` to be an array in the JSON string but got `%s`", jsonObj.get("targets").toString()));
          }

          // validate the optional field `targets` (array)
          for (int i = 0; i < jsonArraytargets.size(); i++) {
            DeferredTargetRequest.validateJsonElement(jsonArraytargets.get(i));
          };
        }
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!PostalRequest.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'PostalRequest' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<PostalRequest> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(PostalRequest.class));

       return (TypeAdapter<T>) new TypeAdapter<PostalRequest>() {
           @Override
           public void write(JsonWriter out, PostalRequest value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public PostalRequest read(JsonReader in) throws IOException {
             JsonElement jsonElement = elementAdapter.read(in);
             validateJsonElement(jsonElement);
             return thisAdapter.fromJsonTree(jsonElement);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of PostalRequest given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of PostalRequest
  * @throws IOException if the JSON string is invalid with respect to PostalRequest
  */
  public static PostalRequest fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, PostalRequest.class);
  }

 /**
  * Convert an instance of PostalRequest to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

